searchNodes=[{"doc":"Bindings and Nx integration for PyTorch . Torchx provides an Nx backend through Torchx.Backend , which allows for integration with both the CPU and GPU functionality that PyTorch provides. To enable Torchx as the default backend you can add the following line to your desired config environment ( config/config.exs , config/test.exs , etc): import Config config :nx , :default_backend , Torchx.Backend This will ensure that by default all tensors are created PyTorch tensors. It's important to keep in mind that the default device is the CPU. If you wish to allocated tensors to the GPU by default, you can pass the :device option to the config line, as follows: import Config config :nx , :default_backend , { Torchx.Backend , device : :cuda } The device_available?/1 function can be used to determine whether :cuda is available. If you have CUDA installed but it doesn't show as available, check out the Installation README section. Types Torchx implements specific names for PyTorch types, which have Nx counterparts as in the following table: Nx Type Torchx Type Description {:u, 8} :byte Unsigned 8-bit integer {:s, 8} :char Signed 8-bit integer {:s, 16} :short Signed 16-bit integer {:s, 32} :int Signed 32-bit integer {:s, 64} :long Signed 64-bit integer {:bf, 16} :brain 16-bit brain floating-point number {:f, 16} :half 16-bit floating-point number {:f, 32} :float 32-bit floating-point number {:f, 64} :double 64-bit floating-point number {:c, 64} :complex 64-bit complex number, with two 32-bit float components {:c, 128} :complex_double 128-bit complex number, with two 64-bit float components Devices PyTorch implements a variety of devices, which can be seen below. For now, only :cpu and :cuda are supported. :cpu :cuda :mkldnn :opengl :opencl :ideep :hip :fpga :msnpu :xla :vulkan :metal :xpu","ref":"Torchx.html","title":"Torchx","type":"module"},{"doc":"","ref":"Torchx.html#abs/1","title":"Torchx.abs/1","type":"function"},{"doc":"","ref":"Torchx.html#acos/1","title":"Torchx.acos/1","type":"function"},{"doc":"","ref":"Torchx.html#acosh/1","title":"Torchx.acosh/1","type":"function"},{"doc":"","ref":"Torchx.html#add/2","title":"Torchx.add/2","type":"function"},{"doc":"","ref":"Torchx.html#all/1","title":"Torchx.all/1","type":"function"},{"doc":"","ref":"Torchx.html#all/3","title":"Torchx.all/3","type":"function"},{"doc":"","ref":"Torchx.html#amax/3","title":"Torchx.amax/3","type":"function"},{"doc":"","ref":"Torchx.html#amin/3","title":"Torchx.amin/3","type":"function"},{"doc":"","ref":"Torchx.html#any/1","title":"Torchx.any/1","type":"function"},{"doc":"","ref":"Torchx.html#any/3","title":"Torchx.any/3","type":"function"},{"doc":"","ref":"Torchx.html#arange/5","title":"Torchx.arange/5","type":"function"},{"doc":"","ref":"Torchx.html#arange/6","title":"Torchx.arange/6","type":"function"},{"doc":"","ref":"Torchx.html#argmax/3","title":"Torchx.argmax/3","type":"function"},{"doc":"","ref":"Torchx.html#argmin/3","title":"Torchx.argmin/3","type":"function"},{"doc":"","ref":"Torchx.html#argsort/3","title":"Torchx.argsort/3","type":"function"},{"doc":"","ref":"Torchx.html#as_strided/4","title":"Torchx.as_strided/4","type":"function"},{"doc":"","ref":"Torchx.html#asin/1","title":"Torchx.asin/1","type":"function"},{"doc":"","ref":"Torchx.html#asinh/1","title":"Torchx.asinh/1","type":"function"},{"doc":"","ref":"Torchx.html#atan2/2","title":"Torchx.atan2/2","type":"function"},{"doc":"","ref":"Torchx.html#atan/1","title":"Torchx.atan/1","type":"function"},{"doc":"","ref":"Torchx.html#atanh/1","title":"Torchx.atanh/1","type":"function"},{"doc":"","ref":"Torchx.html#bitwise_and/2","title":"Torchx.bitwise_and/2","type":"function"},{"doc":"","ref":"Torchx.html#bitwise_not/1","title":"Torchx.bitwise_not/1","type":"function"},{"doc":"","ref":"Torchx.html#bitwise_or/2","title":"Torchx.bitwise_or/2","type":"function"},{"doc":"","ref":"Torchx.html#bitwise_xor/2","title":"Torchx.bitwise_xor/2","type":"function"},{"doc":"","ref":"Torchx.html#broadcast_to/2","title":"Torchx.broadcast_to/2","type":"function"},{"doc":"","ref":"Torchx.html#cbrt/1","title":"Torchx.cbrt/1","type":"function"},{"doc":"","ref":"Torchx.html#ceil/1","title":"Torchx.ceil/1","type":"function"},{"doc":"","ref":"Torchx.html#cholesky/1","title":"Torchx.cholesky/1","type":"function"},{"doc":"","ref":"Torchx.html#cholesky/2","title":"Torchx.cholesky/2","type":"function"},{"doc":"","ref":"Torchx.html#clip/3","title":"Torchx.clip/3","type":"function"},{"doc":"","ref":"Torchx.html#concatenate/2","title":"Torchx.concatenate/2","type":"function"},{"doc":"","ref":"Torchx.html#conjugate/1","title":"Torchx.conjugate/1","type":"function"},{"doc":"","ref":"Torchx.html#conv/7","title":"Torchx.conv/7","type":"function"},{"doc":"","ref":"Torchx.html#cos/1","title":"Torchx.cos/1","type":"function"},{"doc":"","ref":"Torchx.html#cosh/1","title":"Torchx.cosh/1","type":"function"},{"doc":"","ref":"Torchx.html#cumulative_max/2","title":"Torchx.cumulative_max/2","type":"function"},{"doc":"","ref":"Torchx.html#cumulative_min/2","title":"Torchx.cumulative_min/2","type":"function"},{"doc":"","ref":"Torchx.html#cumulative_product/2","title":"Torchx.cumulative_product/2","type":"function"},{"doc":"","ref":"Torchx.html#cumulative_sum/2","title":"Torchx.cumulative_sum/2","type":"function"},{"doc":"","ref":"Torchx.html#delete_tensor/1","title":"Torchx.delete_tensor/1","type":"function"},{"doc":"","ref":"Torchx.html#determinant/1","title":"Torchx.determinant/1","type":"function"},{"doc":"Check if device of the given type is available for Torchx. Device atom can be any of: :cpu :cuda :mkldnn :opengl :opencl :ideep :hip :fpga :msnpu :xla :vulkan :metal :xpu But only :cuda availability check is supported for now.","ref":"Torchx.html#device_available?/1","title":"Torchx.device_available?/1","type":"function"},{"doc":"Return devices quantity for the given device type. Only :cuda is supported for now.","ref":"Torchx.html#device_count/1","title":"Torchx.device_count/1","type":"function"},{"doc":"","ref":"Torchx.html#divide/2","title":"Torchx.divide/2","type":"function"},{"doc":"","ref":"Torchx.html#eigh/1","title":"Torchx.eigh/1","type":"function"},{"doc":"","ref":"Torchx.html#equal/2","title":"Torchx.equal/2","type":"function"},{"doc":"","ref":"Torchx.html#erf/1","title":"Torchx.erf/1","type":"function"},{"doc":"","ref":"Torchx.html#erf_inv/1","title":"Torchx.erf_inv/1","type":"function"},{"doc":"","ref":"Torchx.html#erfc/1","title":"Torchx.erfc/1","type":"function"},{"doc":"","ref":"Torchx.html#exp/1","title":"Torchx.exp/1","type":"function"},{"doc":"","ref":"Torchx.html#expm1/1","title":"Torchx.expm1/1","type":"function"},{"doc":"","ref":"Torchx.html#eye/3","title":"Torchx.eye/3","type":"function"},{"doc":"","ref":"Torchx.html#flip/2","title":"Torchx.flip/2","type":"function"},{"doc":"","ref":"Torchx.html#floor/1","title":"Torchx.floor/1","type":"function"},{"doc":"","ref":"Torchx.html#from_blob/4","title":"Torchx.from_blob/4","type":"function"},{"doc":"Gets a Torchx tensor from a Nx tensor.","ref":"Torchx.html#from_nx/1","title":"Torchx.from_nx/1","type":"function"},{"doc":"","ref":"Torchx.html#full/4","title":"Torchx.full/4","type":"function"},{"doc":"","ref":"Torchx.html#gather/3","title":"Torchx.gather/3","type":"function"},{"doc":"","ref":"Torchx.html#greater/2","title":"Torchx.greater/2","type":"function"},{"doc":"","ref":"Torchx.html#greater_equal/2","title":"Torchx.greater_equal/2","type":"function"},{"doc":"","ref":"Torchx.html#indexed_add/4","title":"Torchx.indexed_add/4","type":"function"},{"doc":"","ref":"Torchx.html#is_tensor/2","title":"Torchx.is_tensor/2","type":"macro"},{"doc":"","ref":"Torchx.html#item/1","title":"Torchx.item/1","type":"function"},{"doc":"","ref":"Torchx.html#left_shift/2","title":"Torchx.left_shift/2","type":"function"},{"doc":"","ref":"Torchx.html#less/2","title":"Torchx.less/2","type":"function"},{"doc":"","ref":"Torchx.html#less_equal/2","title":"Torchx.less_equal/2","type":"function"},{"doc":"","ref":"Torchx.html#log1p/1","title":"Torchx.log1p/1","type":"function"},{"doc":"","ref":"Torchx.html#log/1","title":"Torchx.log/1","type":"function"},{"doc":"","ref":"Torchx.html#logical_and/2","title":"Torchx.logical_and/2","type":"function"},{"doc":"","ref":"Torchx.html#logical_not/1","title":"Torchx.logical_not/1","type":"function"},{"doc":"","ref":"Torchx.html#logical_or/2","title":"Torchx.logical_or/2","type":"function"},{"doc":"","ref":"Torchx.html#logical_xor/2","title":"Torchx.logical_xor/2","type":"function"},{"doc":"","ref":"Torchx.html#logistic/1","title":"Torchx.logistic/1","type":"function"},{"doc":"","ref":"Torchx.html#lu/1","title":"Torchx.lu/1","type":"function"},{"doc":"","ref":"Torchx.html#matmul/2","title":"Torchx.matmul/2","type":"function"},{"doc":"","ref":"Torchx.html#max/2","title":"Torchx.max/2","type":"function"},{"doc":"","ref":"Torchx.html#max_pool_3d/5","title":"Torchx.max_pool_3d/5","type":"function"},{"doc":"","ref":"Torchx.html#min/2","title":"Torchx.min/2","type":"function"},{"doc":"","ref":"Torchx.html#multiply/2","title":"Torchx.multiply/2","type":"function"},{"doc":"","ref":"Torchx.html#narrow/4","title":"Torchx.narrow/4","type":"function"},{"doc":"","ref":"Torchx.html#nbytes/1","title":"Torchx.nbytes/1","type":"function"},{"doc":"","ref":"Torchx.html#negate/1","title":"Torchx.negate/1","type":"function"},{"doc":"","ref":"Torchx.html#normal/5","title":"Torchx.normal/5","type":"function"},{"doc":"","ref":"Torchx.html#not_equal/2","title":"Torchx.not_equal/2","type":"function"},{"doc":"","ref":"Torchx.html#ones/3","title":"Torchx.ones/3","type":"function"},{"doc":"","ref":"Torchx.html#pad/3","title":"Torchx.pad/3","type":"function"},{"doc":"","ref":"Torchx.html#permute/2","title":"Torchx.permute/2","type":"function"},{"doc":"","ref":"Torchx.html#power/2","title":"Torchx.power/2","type":"function"},{"doc":"","ref":"Torchx.html#product/1","title":"Torchx.product/1","type":"function"},{"doc":"","ref":"Torchx.html#product/3","title":"Torchx.product/3","type":"function"},{"doc":"","ref":"Torchx.html#put/3","title":"Torchx.put/3","type":"function"},{"doc":"","ref":"Torchx.html#qr/1","title":"Torchx.qr/1","type":"function"},{"doc":"","ref":"Torchx.html#qr/2","title":"Torchx.qr/2","type":"function"},{"doc":"","ref":"Torchx.html#quotient/2","title":"Torchx.quotient/2","type":"function"},{"doc":"","ref":"Torchx.html#rand/5","title":"Torchx.rand/5","type":"function"},{"doc":"","ref":"Torchx.html#randint/5","title":"Torchx.randint/5","type":"function"},{"doc":"","ref":"Torchx.html#remainder/2","title":"Torchx.remainder/2","type":"function"},{"doc":"","ref":"Torchx.html#reshape/2","title":"Torchx.reshape/2","type":"function"},{"doc":"","ref":"Torchx.html#right_shift/2","title":"Torchx.right_shift/2","type":"function"},{"doc":"","ref":"Torchx.html#round/1","title":"Torchx.round/1","type":"function"},{"doc":"","ref":"Torchx.html#rsqrt/1","title":"Torchx.rsqrt/1","type":"function"},{"doc":"","ref":"Torchx.html#scalar_tensor/3","title":"Torchx.scalar_tensor/3","type":"function"},{"doc":"","ref":"Torchx.html#scalar_type/1","title":"Torchx.scalar_type/1","type":"function"},{"doc":"","ref":"Torchx.html#shape/1","title":"Torchx.shape/1","type":"function"},{"doc":"","ref":"Torchx.html#sign/1","title":"Torchx.sign/1","type":"function"},{"doc":"","ref":"Torchx.html#sin/1","title":"Torchx.sin/1","type":"function"},{"doc":"","ref":"Torchx.html#sinh/1","title":"Torchx.sinh/1","type":"function"},{"doc":"","ref":"Torchx.html#solve/2","title":"Torchx.solve/2","type":"function"},{"doc":"","ref":"Torchx.html#sort/3","title":"Torchx.sort/3","type":"function"},{"doc":"","ref":"Torchx.html#split/2","title":"Torchx.split/2","type":"function"},{"doc":"","ref":"Torchx.html#sqrt/1","title":"Torchx.sqrt/1","type":"function"},{"doc":"","ref":"Torchx.html#squeeze/1","title":"Torchx.squeeze/1","type":"function"},{"doc":"","ref":"Torchx.html#squeeze/2","title":"Torchx.squeeze/2","type":"function"},{"doc":"","ref":"Torchx.html#subtract/2","title":"Torchx.subtract/2","type":"function"},{"doc":"","ref":"Torchx.html#sum/3","title":"Torchx.sum/3","type":"function"},{"doc":"","ref":"Torchx.html#svd/1","title":"Torchx.svd/1","type":"function"},{"doc":"","ref":"Torchx.html#svd/2","title":"Torchx.svd/2","type":"function"},{"doc":"","ref":"Torchx.html#tan/1","title":"Torchx.tan/1","type":"function"},{"doc":"","ref":"Torchx.html#tanh/1","title":"Torchx.tanh/1","type":"function"},{"doc":"","ref":"Torchx.html#tensordot/4","title":"Torchx.tensordot/4","type":"function"},{"doc":"","ref":"Torchx.html#to_blob/1","title":"Torchx.to_blob/1","type":"function"},{"doc":"","ref":"Torchx.html#to_blob/2","title":"Torchx.to_blob/2","type":"function"},{"doc":"","ref":"Torchx.html#to_device/2","title":"Torchx.to_device/2","type":"function"},{"doc":"Converts a Torchx tensor to a Nx tensor.","ref":"Torchx.html#to_nx/1","title":"Torchx.to_nx/1","type":"function"},{"doc":"","ref":"Torchx.html#to_type/2","title":"Torchx.to_type/2","type":"function"},{"doc":"","ref":"Torchx.html#transpose/3","title":"Torchx.transpose/3","type":"function"},{"doc":"","ref":"Torchx.html#triangular_solve/4","title":"Torchx.triangular_solve/4","type":"function"},{"doc":"","ref":"Torchx.html#unfold/4","title":"Torchx.unfold/4","type":"function"},{"doc":"","ref":"Torchx.html#view_as_real/1","title":"Torchx.view_as_real/1","type":"function"},{"doc":"","ref":"Torchx.html#where/3","title":"Torchx.where/3","type":"function"},{"doc":"An opaque backend Nx backend with bindings to libtorch/Pytorch. Torchx behaviour that is different from BinaryBackend: Torchx doesn't support u16/u32/u64. Only u8 is supported. iex&gt; Nx.tensor([1, 2, 3], type: {:u, 16}, backend: Torchx.Backend) ** (ArgumentError) Torchx does not support unsigned 16 bit integer Torchx doesn't support u8 on sums, you should convert input to signed integer. iex&gt; Nx.sum(Nx.tensor([1, 2, 3], type: {:u, 8}, backend: Torchx.Backend)) ** (ArgumentError) Torchx does not support unsigned 64 bit integer (explicitly cast the input tensor to a signed integer before taking sum) Torchx rounds half-to-even, while Elixir rounds half-away-from-zero. So in Elixir round(0.5) == 1.0 while in Torchx round(0.5) == 0.0 . Nx.as_type/2 converts non-finite values such as infinity becomes the maximum value for a type, negative infinity becomes the minimum value, and nan becomes zero. Torchx behaviour is type dependent with no clear rule across types. Options :device - Defaults to :cpu . An atom representing the device for the allocation of a given tensor. Valid values can be seen at the main Torchx docs.","ref":"Torchx.Backend.html","title":"Torchx.Backend","type":"module"},{"doc":"","ref":"Torchx.Backend.html#steps_to_strides/2","title":"Torchx.Backend.steps_to_strides/2","type":"function"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"First release.","ref":"changelog.html#v0-2-0-2022-04-28","title":"Changelog - v0.2.0 (2022-04-28)","type":"extras"}]